// ○○まであと何日を返す
function ryus_xmoredays($atts) {
	/* 引数を展開する */
	extract(
		shortcode_atts(
			array(
				'date' => '',
			),
			$atts
		)
	);
    $dateArray = array();
	$dateArray = _dateExplode($date);

	if(count($dateArray) != 3){
		return '';
	}
	if(checkdate ( $dateArray[1] , $dateArray[2] , $dateArray[0] )){
		// 日付として妥当だったら
		$today=mktime(0,0,0,date("m"),date("d"),date("Y"));
		$theDay=mktime(0,0,0,$dateArray[1],$dateArray[2],$dateArray[0]);
		$days = ($theDay - $today) /86400;
		return $days;
	}
	return '';
}

// from,toで囲まれた日だったら中に指定してあるショートコードを実行する
function ryus_during($atts, $content) {
	/* 引数を展開する */
	extract(
		shortcode_atts(
			array(
				'to' => '',
				'from' => '',
			),
			$atts
		)
	);
	$dateArrayTo = _dateExplode($to);
	$dateArrayFrom = _dateExplode($from);
	// 日付妥当性
	if (count($dateArrayTo) > 0){
		if(_dateCheck($dateArrayTo) == false){
			return '';
		}
	}
	if (count($dateArrayFrom) > 0){
		if(_dateCheck($dateArrayFrom) == false){
			return '';
		}
	}
	
	$todayDate = date("Y").date("m").date("d");
	$fromDate = '00000000';
	$toDate = '99999999';
	if(count($dateArrayFrom) == 3){
		$fromDate = $dateArrayFrom[0].$dateArrayFrom[1].$dateArrayFrom[2];
	}
	if(count($dateArrayTo) == 3){
		$toDate = $dateArrayTo[0].$dateArrayTo[1].$dateArrayTo[2];
	}
	if(($fromDate <= $todayDate) AND ($toDate >= $todayDate)){
		return do_shortcode($content);
	}
	return '';
}
add_shortcode('ryus_during', 'ryus_during');

function _dateCheck($dateArray) {
	if(count($dateArray) != 3) {
		return false;
	} else {
		if(checkdate ( intval($dateArray[1]) , intval($dateArray[2]) , intval($dateArray[0]) )){
			return true;
		} else {
			return false;
		}
	}
}

function _dateExplode($date) {
	$dateArray = array();
	if($date != ''){
		if(strpos($date, '/') !== false){
			$dateArray = explode("/", $date);
		} else {
			$dateArray = explode("-", $date);
		}
	}
	if(count($dateArray) == 3){
		$dateArray[1] = substr('0'.$dateArray[1], -2);
		$dateArray[2] = substr('0'.$dateArray[2], -2);
	}
	return $dateArray;
}

add_shortcode('ryus_xmoredays', 'ryus_xmoredays');